/* 

                          Firewall Builder

                 Copyright (C) 2003 NetCitadel, LLC

  Author:  Illiya Yalovoy <yalovoy@gmail.com>

  $Id: FWObjectDropArea.h,v 1.2 2006/10/22 04:39:36 vkurland Exp $

  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef __FWOBJECTDROPAREA_H_
#define __FWOBJECTDROPAREA_H_

#include "config.h"
#include <fwobjectdroparea_q.h>

#include "fwbuilder/FWObject.h"

class QWidget;
class QPixmap;
class QPopupMenu;
class QContextMenuEvent;
class QDropEvent;
class QDragEnterEvent;

class FWObjectDropArea : public FWObjectDropArea_q
{
    Q_OBJECT
 private:
        libfwbuilder::FWObject *object;
 protected:
        void paintEvent(QPaintEvent *ev);
        void contextMenuEvent (QContextMenuEvent * e);
        void dropEvent( QDropEvent *ev);
        void dragEnterEvent( QDragEnterEvent *ev);
        
 public:
    FWObjectDropArea(QWidget*p, const char * n = 0, WFlags f = 0);
    libfwbuilder::FWObject * getObject(){return object;};
    
    bool isEmpty() {return object==NULL;};

public slots:
    void insertObject(libfwbuilder::FWObject *o);
    void deleteObject();
    void pasteObject();
    
 signals:
    void objectDeleted();
    void objectInserted();
    
};

#endif 
