#-*- mode: makefile; tab-width: 4; -*-
#
#
TEMPLATE	= app
LANGUAGE	= C++

HEADERS	+= ../../config.h \
	utils.h \
	utils_no_qt.h \
    Importer.h \
    IOSImporter.h \
	SSHSession.h \
	SSHUnx.h \
	SSHPIX.h \
	SSHIOS.h \
	debugDialog.h \
	findDialog.h \
	longTextDialog.h \
	newGroupDialog.h \
	filePropDialog.h \
	DialogData.h \
	InterfaceData.h \
	execDialog.h \
	SimpleTextEditor.h \
	SimpleIntEditor.h \
	FWBSettings.h \
	FWBTree.h \
	RCS.h \
	RCSFileDialog.h \
	RCSFilePreview.h \
	FWObjectClipboard.h \
	platforms.h \
	global.h \
	FWWindow.h \
	printerStream.h \
	PrintingProgressDialog.h \
	FWObjectPropertiesFactory.h \
	ObjectManipulator.h \
	ObjectEditor.h \
	FWObjectDrag.h \
	ObjectTreeView.h \
	ObjectListView.h \
	ObjectIconView.h \
	ObjectTreeViewItem.h \
	InstallFirewallViewItem.h \
	DialogFactory.h \
	HostDialog.h \
	FirewallDialog.h \
	InterfaceDialog.h \
	AddressRangeDialog.h \
	AddressTableDialog.h \
	IPv4Dialog.h \
	PhysicalAddressDialog.h \
	NetworkDialog.h \
	LibraryDialog.h \
	CustomServiceDialog.h \
	IPServiceDialog.h \
	ICMPServiceDialog.h \
	TCPServiceDialog.h \
	UDPServiceDialog.h \
	GroupObjectDialog.h \
	ObjectIconViewItem.h \
	TimeDialog.h \
	RuleSetView.h \
	inplaceComboBox.h \
	iptAdvancedDialog.h \
	ipfAdvancedDialog.h \
	ipfwAdvancedDialog.h \
	pfAdvancedDialog.h \
	pixAdvancedDialog.h \
	pixosAdvancedDialog.h \
	iosaclAdvancedDialog.h \
	iosAdvancedDialog.h \
	linux24AdvancedDialog.h \
	linksysAdvancedDialog.h \
	freebsdAdvancedDialog.h \
	openbsdAdvancedDialog.h \
	solarisAdvancedDialog.h \
	macosxAdvancedDialog.h \
	RuleOptionsDialog.h \
	RoutingRuleOptionsDialog.h \
	NATRuleOptionsDialog.h \
	LibExportDialog.h \
	PrefsDialog.h \
	instConf.h \
	instDialog.h \
	newFirewallDialog.h \
	newHostDialog.h \
	ObjConflictResolutionDialog.h \
	listOfLibraries.h \
	ColorLabelMenuItem.h \
	TagServiceDialog.h \
	ActionsDialog.h \
	SimpleTextView.h \
	DiscoveryDruid.h \
	DNSNameDialog.h \
	instOptionsDialog.h \
	instBatchOptionsDialog.h \
	FilterDialog.h \
	FindObjectWidget.h \
	FWObjectDropArea.h \
	CommentEditorPanel.h \
	MetricEditorPanel.h \
	FindWhereUsedWidget.h \
	ConfirmDeleteObjectDialog.h

SOURCES	+= main.cpp \
	utils.cpp \
	utils_no_qt.cpp \
    Importer.cpp \
    IOSImporter.cpp \
    IOSImporterRun.cpp \
	SSHSession.cpp \
	SSHUnx.cpp \
	SSHPIX.cpp \
	SSHIOS.cpp \
	debugDialog.cpp \
	findDialog.cpp \
	longTextDialog.cpp \
	newGroupDialog.cpp \
	filePropDialog.cpp \
	DialogData.cpp \
	InterfaceData.cpp \
	execDialog.cpp \
	SimpleTextEditor.cpp \
	SimpleIntEditor.cpp \
	FWBSettings.cpp \
	FWBTree.cpp \
	RCS.cpp \
	RCSFileDialog.cpp \
	RCSFilePreview.cpp \
	FWObjectClipboard.cpp \
	platforms.cpp \
	FWWindow.cpp \
	FWWindowPrint.cpp \
	printerStream.cpp \
	PrintingProgressDialog.cpp \
	FWObjectPropertiesFactory.cpp \
	ObjectManipulator.cpp \
	ObjectEditor.cpp \
	FWObjectDrag.cpp \
	ObjectTreeView.cpp \
	ObjectListView.cpp \
	ObjectIconView.cpp \
	DialogFactory.cpp \
	HostDialog.cpp \
	FirewallDialog.cpp \
	InterfaceDialog.cpp \
	AddressRangeDialog.cpp \
	AddressTableDialog.cpp \
	IPv4Dialog.cpp \
	PhysicalAddressDialog.cpp \
	NetworkDialog.cpp \
	LibraryDialog.cpp \
	CustomServiceDialog.cpp \
	IPServiceDialog.cpp \
	ICMPServiceDialog.cpp \
	TCPServiceDialog.cpp \
	UDPServiceDialog.cpp \
	GroupObjectDialog.cpp \
	TimeDialog.cpp \
	RuleSetView.cpp \
	inplaceComboBox.cpp \
	iptAdvancedDialog.cpp \
	ipfAdvancedDialog.cpp \
	ipfwAdvancedDialog.cpp \
	pfAdvancedDialog.cpp \
	pixAdvancedDialog.cpp \
	pixosAdvancedDialog.cpp \
	iosaclAdvancedDialog.cpp \
	iosAdvancedDialog.cpp \
	linux24AdvancedDialog.cpp \
	linksysAdvancedDialog.cpp \
	freebsdAdvancedDialog.cpp \
	openbsdAdvancedDialog.cpp \
	solarisAdvancedDialog.cpp \
	macosxAdvancedDialog.cpp \
	RuleOptionsDialog.cpp \
	RoutingRuleOptionsDialog.cpp \
	NATRuleOptionsDialog.cpp \
	LibExportDialog.cpp \
	PrefsDialog.cpp \
	instConf.cpp \
	instDialog.cpp \
	newFirewallDialog.cpp \
	newHostDialog.cpp \
	ObjConflictResolutionDialog.cpp \
	listOfLibraries.cpp \
	ColorLabelMenuItem.cpp \
	TagServiceDialog.cpp \
	ActionsDialog.cpp \
	SimpleTextView.cpp \
	DiscoveryDruid.cpp \
	DNSNameDialog.cpp \
	ObjectTreeViewItem.cpp \
	InstallFirewallViewItem.cpp \
	instOptionsDialog.cpp \
	instBatchOptionsDialog.cpp \
	FilterDialog.cpp \
	FindObjectWidget.cpp \
	FWObjectDropArea.cpp \
	CommentEditorPanel.cpp \
	MetricEditorPanel.cpp \
	FindWhereUsedWidget.cpp \
	ConfirmDeleteObjectDialog.cpp

FORMS	= FWBMainWindow_q.ui \
	execdialog_q.ui \
	customservicedialog_q.ui \
	ipservicedialog_q.ui \
	icmpservicedialog_q.ui \
	tcpservicedialog_q.ui \
	udpservicedialog_q.ui \
	groupobjectdialog_q.ui \
	librarydialog_q.ui \
	ipv4dialog_q.ui \
	addressrangedialog_q.ui \
	addresstabledialog_q.ui \
	networkdialog_q.ui \
	hostdialog_q.ui \
	firewalldialog_q.ui \
	interfacedialog_q.ui \
	physaddressdialog_q.ui \
	timedialog_q.ui \
	rcsfilepreview_q.ui \
	rcsfilesavedialog_q.ui \
	iptadvanceddialog_q.ui \
	objectmanipulator_q.ui \
	prefsdialog_q.ui \
	pixadvanceddialog_q.ui \
	pixosadvanceddialog_q.ui \
	iosacladvanceddialog_q.ui \
	iosadvanceddialog_q.ui \
	simpletexteditor_q.ui \
	simpleinteditor_q.ui \
	aboutdialog_q.ui \
	libexport_q.ui \
	ruleoptionsdialog_q.ui \
	routingruleoptionsdialog_q.ui \
	instdialog_q.ui \
	objconflictresolutiondialog_q.ui \
	newfirewalldialog_q.ui \
	finddialog_q.ui \
	ipfadvanceddialog_q.ui \
	ipfwadvanceddialog_q.ui \
	pfadvanceddialog_q.ui \
	linux24advanceddialog_q.ui \
	solarisadvanceddialog_q.ui \
	freebsdadvanceddialog_q.ui \
	openbsdadvanceddialog_q.ui \
	macosxadvanceddialog_q.ui \
	colorlabelmenuitem_q.ui \
	debugdialog_q.ui \
	filepropdialog_q.ui \
	askrulenumberdialog_q.ui \
	newgroupdialog_q.ui \
	newhostdialog_q.ui \
	longtextdialog_q.ui \
	linksysadvanceddialog_q.ui \
	printingprogressdialog_q.ui \
	pagesetupdialog_q.ui \
	dnsnamedialog_q.ui \
	tagservicedialog_q.ui \
	actionsdialog_q.ui \
	simpletextview_q.ui \
	discoverydruid_q.ui \
	filterdialog_q.ui \
	natruleoptionsdialog_q.ui \
	instoptionsdialog_q.ui \
	findobjectwidget_q.ui \
	fwobjectdroparea_q.ui \
	commenteditorpanel_q.ui \
	metriceditorpanel_q.ui \
	findwhereusedwidget_q.ui \
	confirmdeleteobjectdialog_q.ui

IMAGES	= images/filenew \
	images/fileopen \
	images/filesave \
	images/print \
	images/undo \
	images/redo \
	images/editcut \
	images/editcopy \
	images/editpaste \
	images/searchfind \
	icons/accept_25.png \
	icons/accounting_25.png \
	icons/address-neg_25.png \
	icons/address-ref_25.png \
	icons/address_16.png \
	icons/address_25.png \
	icons/addresstable-neg_25.png \
	icons/addresstable-ref_25.png \
	icons/addresstable_16.png \
	icons/addresstable_25.png \
	icons/apply.png \
	icons/back_25.png \
	icons/back_32.png \
	icons/big-down-arrow.png \
	icons/big-left-arrow.png \
	icons/big-right-arrow.png \
	icons/big-up-arrow.png \
	icons/binoculars64.png \
	icons/blank.png \
	icons/blank_2x16.png \
	icons/books1.png \
	icons/both.png \
	icons/branch_25.png \
	icons/cancel.png \
	icons/cert_druid_logo.png \
	icons/check.png \
	icons/classify_25.png \
	icons/clock-group-neg_25.png \
	icons/clock-group-ref_25.png \
	icons/clock-group_16.png \
	icons/clock-group_25.png \
	icons/clock-neg_25.png \
	icons/clock-ref_25.png \
	icons/clock_16.png \
	icons/clock_25.png \
	icons/close.png \
	icons/compile_25.png \
	icons/continue_25.png \
	icons/custom_25.png \
	icons/deny_25.png \
	icons/domainname-neg_25.png \
	icons/domainname-ref_25.png \
	icons/domainname_16.png \
	icons/domainname_25.png \
	icons/down-arrow.png \
	icons/drag_object.png \
	icons/error.png \
	icons/firewall-neg_25.png \
	icons/firewall-ref_25.png \
	icons/firewall_16.png \
	icons/firewall_25.png \
	icons/floppy.png \
	icons/folder1.png \
	icons/generic.png \
	icons/host-neg_25.png \
	icons/host-ref_25.png \
	icons/host_16.png \
	icons/host_25.png \
	icons/host_64.png \
	icons/inbound.png \
	icons/info_25.png \
	icons/install_25.png \
	icons/interface-neg_25.png \
	icons/interface-ref_25.png \
	icons/interface_16.png \
	icons/interface_25.png \
	icons/key.png \
	icons/left-arrow.png \
	icons/library_16.png \
	icons/library_25.png \
	icons/lock.png \
	icons/log.png \
	icons/log_25.png \
	icons/neg.png \
	icons/network-neg_25.png \
	icons/network-ref_25.png \
	icons/network_16.png \
	icons/network_25.png \
	icons/newfile_25.png \
	icons/newobject_25.png \
	icons/newobject_32.png \
	icons/no.png \
	icons/object-group-neg_25.png \
	icons/object-group-ref_25.png \
	icons/object-group_16.png \
	icons/object-group_25.png \
	icons/ok.png \
	icons/openfile_25.png \
	icons/options_25.png \
	icons/outbound.png \
	icons/physaddress-neg_25.png \
	icons/physaddress-ref_25.png \
	icons/physaddress_16.png \
	icons/physaddress_25.png \
	icons/pipe_25.png \
	icons/protect_host.png \
	icons/protect_net.png \
	icons/protect_net_and_dmz.png \
	icons/question.png \
	icons/rangeaddress-neg_25.png \
	icons/rangeaddress-ref_25.png \
	icons/rangeaddress_16.png \
	icons/rangeaddress_25.png \
	icons/redo.png \
	icons/ref.png \
	icons/reject_25.png \
	icons/right-arrow.png \
	icons/route_25.png \
	icons/rules_druid_logo.png \
	icons/save_25.png \
	icons/search_25.png \
	icons/service-custom-neg_25.png \
	icons/service-custom-ref_25.png \
	icons/service-custom_16.png \
	icons/service-custom_25.png \
	icons/service-group-neg_25.png \
	icons/service-group-ref_25.png \
	icons/service-group_16.png \
	icons/service-group_25.png \
	icons/service-icmp-neg_25.png \
	icons/service-icmp-ref_25.png \
	icons/service-icmp_16.png \
	icons/service-icmp_25.png \
	icons/service-ip-neg_25.png \
	icons/service-ip-ref_25.png \
	icons/service-ip_16.png \
	icons/service-ip_25.png \
	icons/service-tag-neg_25.png \
	icons/service-tag-ref_25.png \
	icons/service-tag_16.png \
	icons/service-tag_25.png \
	icons/service-tcp-neg_25.png \
	icons/service-tcp-ref_25.png \
	icons/service-tcp_16.png \
	icons/service-tcp_25.png \
	icons/service-udp-neg_25.png \
	icons/service-udp-ref_25.png \
	icons/service-udp_16.png \
	icons/service-udp_25.png \
	icons/stop.png \
	icons/tag_25.png \
	icons/uncheck.png \
	icons/undo.png \
	icons/up-arrow.png \
	icons/warning.png \
	icons/yes.png \
	icons/firewall_64.png

	HEADERS += IPTImporter.h
	SOURCES += IPTImporter.cpp IPTImporterRun.cpp

#
include(../../qmake.inc)
#
exists(qmake.inc) {
  include( qmake.inc)
}

#
#
#
#
TARGET = fwbuilder
#

contains( HAVE_ANTLR_RUNTIME, 1 ) {
	INCLUDEPATH	 += $$ANTLR_INCLUDEPATH
	LIBS		 += $$FWBPARSER_LIB  $$ANTLR_LIBS 
	DEFINES		 += $$ANTLR_DEFINES
}

#unix  {
#  !macx {
#      #  }
#}

QMAKE_COPY    = ../../install.sh -m 0755 -s

